
create or replace function pgq.get_batch_info(x_batch_id bigint)
returns pgq.ret_batch_info as $$
declare
    ret  pgq.ret_batch_info%rowtype;
begin
    select q.queue_name, c.consumer_name,
           prev.tick_time as batch_start,
           cur.tick_time as batch_end,
           b.prev_tick_id, b.tick_id,
           current_timestamp - cur.tick_time as lag
        into ret
        from pgq.active_batch b, pgq.tick cur, pgq.tick prev,
             pgq.queue_config q, pgq.consumer c
        where b.batch_id = x_batch_id
          and prev.tick_id = b.prev_tick_id
          and prev.queue_id = b.queue_id
          and cur.tick_id = b.prev_tick_id
          and cur.queue_id = b.queue_id
          and q.queue_id = b.queue_id
          and c.consumer_id = b.consumer_id;
    return ret;
end;
$$ language plpgsql security definer;

