
create or replace function pgq.get_consumer_list(x_queue_name text)
returns setof pgq.ret_consumer_list as $$
declare
    ret  pgq.ret_consumer_list%rowtype;
begin
    for ret in 
        select q.queue_name, c.consumer_name, wm.thread_timeout,
               current_timestamp - t.tick_time as lag,
               current_timestamp - wm.last_modified_date as last_seen
          from pgq.high_watermark wm, pgq.tick t, pgq.queue_config q,
               pgq.consumer c
         where t.tick_id = wm.last_tick_id
           and q.queue_id = wm.queue_id
           and t.queue_id = wm.queue_id
           and c.consumer_id = wm.consumer_id
           and q.queue_name = x_queue_name
         order by 1,2
    loop
        return next ret;
    end loop;
    return;
end;
$$ language plpgsql security definer;

create or replace function pgq.get_consumer_list()
returns setof pgq.ret_consumer_list as $$
declare
    ret  pgq.ret_consumer_list%rowtype;
    i    record;
begin
    for i in select queue_name from pgq.queue_config order by 1
    loop
        for ret in
            select * from pgq.get_consumer_list(i.queue_name)
        loop
            return next ret;
        end loop;
    end loop;
    return;
end;
$$ language plpgsql security definer;

