create or replace function pgq.grant_perms(x_queue_name text)
returns integer as $$
declare
    cf    record;
    i     integer;
begin
    select * from pgq.queue_config into cf
        where queue_name = x_queue_name;
    if not found then
        raise exception 'Queue not found';
    end if;
    execute 'grant select, update on '
        || cf.event_seq_name || ',' || cf.tick_seq_name
        || ' to public';
    execute 'grant select on '
        || cf.table_name
        || ' to public';
    for i in 0 .. cf.number_of_event_tables - 1 loop
        execute 'grant select, insert on '
            || cf.table_name || '_' || i
            || ' to public';
    end loop;
    return 1;
end;
$$ language plpgsql security definer;

