create or replace function pgq.maint_clean_batch_log()
returns integer as $$
-- deletes old events from batch_log
declare
    badcnt  integer;
    res     integer;
    cf      record;
    nr      integer;
    tbl     text;
begin
    res := 0;
    for cf in
        select * from pgq.queue_config
            where batch_log_timeout is not null
    loop
        delete from pgq.batch_log
         where batch_start < current_timestamp - cf.batch_log_timeout
           and queue_id = cf.queue_id;
    end loop;
    return res;
end;
$$ language plpgsql; -- need admin access

