create or replace function pgq.maint_purge_threads()
returns integer as $$
declare
    batch record;
    res      integer;
begin
    res := 0;
    for batch in
        select * from pgq.active_batch b, pgq.high_watermark hwm
            where b.queue_id = hwm.queue_id
              and b.consumer_id = hwm.consumer_id
              and hwm.thread_timeout is not null
              and b.last_modified_date + hwm.thread_timeout < current_timestamp
    loop
        perform pgq.batch_retry(batch.batch_id, 60);
        perform pgq.finish_batch(batch.batch_id);
        res := res + 1;
    end loop;
    return res;
end;
$$ language plpgsql; -- need admin access

