create type pgq.ret_event_data as (
    event_id bigint,
    ref_id text,
    payload text,
    producer text,
    creation_date timestamptz,
    event_txid bigint,
    retry_count integer
);

create type pgq.ret_failed_event_data as (
    event_id bigint,
    ref_id text,
    payload text,
    producer text,
    creation_date timestamptz,
    retry_count integer,
    failure_date timestamptz,
    failure_reason text
);

create type pgq.ret_queue_list as (
  queue_name text,
  rotation_delay interval,
  num_tables smallint,
  event_timeout interval, -- unused
  -- tick_max_amount integer,
  -- tick_max_lag integer,
  -- tick_idle_interval integer,
  -- external_ticker boolean,
  -- creation_date timestamptz,
  ticker_lag interval
);

create type pgq.ret_consumer_list as (
  queue_name text,
  consumer_name text,
  thread_timeout interval,
  lag interval,
  last_seen interval
);

create type pgq.ret_batch_info as (
  queue_name text,
  consumer_name text,
  batch_start timestamptz,
  batch_end timestamptz,
  prev_tick_id bigint,
  tick_id bigint,
  lag interval
);

-- drop type pgq.ret_stats cascade;
create type pgq.ret_stats as (
    queue_name          text,
    consumer_name       text,
    avg_batch_time      interval,
    avg_lag             interval,
    max_lag             interval,
    avg_batch           decimal(20,3),
    max_batch           bigint,
    total_count         bigint,
    total_retry         bigint,
    total_failed        bigint,
    avg_events_per_sec  decimal(20,3),
    guess_speed         decimal(20,3)
);

